diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
index ad2fda1caa..83b4c8f94f 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
@@ -39,59 +39,526 @@
 #include <sys/cred.h>
 #include <sys/stat.h>
 #include <sys/mkdev.h>
-#include <sys/queue.h>
 #include <sys/containerof.h>
 #include <sys/sensors.h>
 #include <sys/firmload.h>
 #include <sys/mac_provider.h>
 #include <sys/mac_ether.h>
 #include <sys/vlan.h>
+#include <sys/cpuvar.h>
 
 #include "common/common.h"
 #include "common/t4_msg.h"
 #include "common/t4_regs.h"
 #include "common/t4_extra_regs.h"
 
+/*
+ * Nexus driver for Chelsio Terminator Network Adapters (T4/T5/T6)
+ *
+ * This driver supports the Chelsio Terminator series of network adapters
+ * starting with the T4 generation and onward. These adapters present a "unified
+ * wire" for managing traditional L2 Ethernet traffic alongside a variety of
+ * stateful offloads including the usual TCP/UDP protocols along with storage
+ * technology like iSCSI, FCoE, NVMe over fabrics, and others. All of these
+ * features coexist on a single ASIC controlled by a single firmware image, thus
+ * the "unified wire". While these adapters provide many offload technologies,
+ * this driver remains focused on providing L2 Ethernet services as presented by
+ * the GLDv3/mac framework. In short, this consists of presenting the device as
+ * groups of rings with filtering and steering capabilities along with stateless
+ * offloads including checksums and LSO. This nexus driver does not preclude the
+ * support of the stateful offload features, but supporting them requires
+ * additional work both inside this driver along with general operating system
+ * enhancements.
+ *
+ * Naming & Terminology
+ * --------------------
+ *
+ * CPL:
+ *
+ *     Chelsio Protocol Language messages. We use these to wrap network data for
+ *     Tx and Rx, this wrapping of packets in CPL is referred to by Chelsio as
+ *     "tunneled" data. Not be to confused with the more general network
+ *     tunneling also known as encapsulation (e.g. IP tunnling, VXLAN, etc).
+ *
+ * Flit:
+ *
+ *     A 64-bit (8 byte) quantity. The Chelsio documentation and code divides
+ *     communication structures into units of flits. For example, a firmware
+ *     command may consist of up to 8 flits (8-bytes x 8 = 64 bytes) where the
+ *     command header is always made up of the first two flits and the remaining
+ *     6 may be used for variable payload data.
+ *
+ * Module/Block:
+ *
+ *     The T4 is comprised of various modules (also referred to as a "block" or
+ *     "engine" in some contexts) which work together to provide the services
+ *     offered by the chip. For example, the Scatter-Gather Engine (SGE) module
+ *     provides the DMA communications used to send and receive traffic.
+ *
+ * T4:
+ *
+ *     The short name to represent any Chelsio Terminator ASIC from the T4 and
+ *     onward. This includes the T4, T5, and T6 line of parts.
+ *
+ * Tunneled Traffic:
+ *
+ *     The Chelsio documentation often refers to sending or receiving "tunneled"
+ *     traffic, but it's not referring to the traditional networking terminology
+ *     of encapsulated data. Rather, it is referring to traffic that is
+ *     sent/received in a non-offload capacity. It's called "tunneled" because
+ *     the data is wrapped/"tunneled" in Work Requests and CPL messages. This
+ *     driver deals purely in tunneled traffic as it make no use of stateful
+ *     offloads.
+ *
+ * ULPTX
+ *
+ *    The Upper Layer Processing Transmit module handle DMA access related to
+ *    egress traffic.
+ *
+ * Work Request (WR)
+ *
+ *    Work Requests are commands and data descriptors use to send Tx packets.
+ *
+ * Communication
+ * -------------
+ *
+ * Before any requests can be made or any data can be transmitted we must first
+ * establish communication with the device. The Chelsio Terminator ASIC, or T4
+ * for short, presents four primary methods of communication between the driver
+ * and itself.
+ *
+ * 1. Registers: read/write simple values or bitwise data over PIO
+ *
+ * 2. Mailboxes: synchronized request/reply structured data over PIO
+ *
+ * 3. Queues: DMA memory of structured data for control and data plane
+ *
+ * 4. Interrupts: MSI/MSI-X interrupts for indicating queue status updates or
+ *    asynchronous events from the firmware
+ *
+ * The first access we have is to the registers via our BAR0 mapping. These
+ * registers provide control and configuration over many aspects of the
+ * different modules that make up the T4.
+ *
+ * Using the registers we then establish a mailbox which provides structured
+ * communication in the form of request/reply commands to the firmware. Both of
+ * these methods use Programmed I/O which is fine for administrative control,
+ * but inadequate for the latency and throughput demands of the datapath and its
+ * associated control plane.
+ *
+ * For the datapath we use the registers and mailbox to establish queues of DMA
+ * memory for transmitting and receiving data. Queues deal in Work Requests
+ * (WR), Chelsio Protocol Language messages (CPL), and Freelist buffer pointers
+ * (FL). These data structures may subsequently point to other DMA memory
+ * (buffers) that hold the data to be transmitted or received along with its
+ * associated software descriptors.
+ *
+ * Finally, the T4 provides various types of interrupt control to asynchronously
+ * signal the driver of conditions such as errors, firmware events, and datapath
+ * (queue) synchronization via status updates (cidx/pidx).
+ *
+ * While nothing precludes the driver from consuming directly these forms of
+ * communication, most of the interface with the T4 is currently provided by the
+ * "common code" interfaces. This common code is, nominally, code shared between
+ * the various operating systems for interacting with the T4.
+ *
+ * Queues (Rings)
+ * --------------
+ *
+ * Queues are circular buffers of DMA memory used to share structured data often
+ * referred to as a "descriptor". These circular buffers are also commonly
+ * called rings. Where each entry in the ring is a descriptor used for locating
+ * and describing data that is meant to be transmitted across or received from
+ * the network device.
+ *
+ * The T4 queues are used in this manner, to share descriptors between the
+ * driver and device, but their level of synchronization is not technically a
+ * descriptor. Rather, a queue is made up of a number of "host credits". The
+ * size of a host credit (sometimes also called an "entry" or "descriptor" in
+ * the code) depends on the type of queue and how it is configured. This
+ * difference in terminology between "host credit" vs. "descriptor" is mostly
+ * pertinent to Egress Queues, which always have 64-byte (8-flit) host credits.
+ * Those host credits are used to pass variable-sized Work Requests (WR), the
+ * structure which actually acts as the "descriptor", which may be smaller or
+ * larger than a single credit. Ingress Queues (IQ) also have variable-sized
+ * entries, but the size is determined at queue creation time and is uniform for
+ * each entry; therefore IQ entries can be called credits, entries, or
+ * descriptors without any real confusion. The official Chelsio documentation
+ * also uses mixed terminology, so it's important to keep that in mind. However,
+ * regardless of how many credits a descriptor requires, communication always
+ * occurs in units of whole credits. A good way to frame this is that queues
+ * provide logical rings of descriptors (WRs, CPLs, FLs) on top of physical
+ * units of host credits.
+ *
+ * There are different types of queues for different purposes, but they are all
+ * variations of either an Ingress Queue (IQ) or Egress Queue (EQ). As the names
+ * suggest, a queue is a unidirectional communication channel: one is the
+ * producer and the other side is a consumer. The Ingress Queue provides
+ * communication from T4 (producer) to driver (consumer), and the Egress Queue
+ * provides communication from the driver (producer) to the T4 (consumer).
+ *
+ * The producer/consumer synchronize communication in units of host credits. The
+ * producer tracks its next host credit to write under the producer index
+ * (pidx), and the consumer tracks its next host credit to read under the
+ * consumer index (cidx). These values are kept in sync through means such as
+ * doorbells (DB), Go-To-Sleep updates (GTS), and interrupts carrying CPL
+ * message (e.g. CPL_SGE_EGR_UPDATE).
+ *
+ * If you read the Terminator Programmer's Guide you will find dicussion about
+ * the queue's "context". This is described as an area of memory that dictates
+ * various features and behavior of the queue. While this queue context may at
+ * one point have been programmed directly, it no longer is. Rather, the various
+ * aspects of queue behavior are controlled by parameters passed during the
+ * queue creation firmware commands, along with other mechanisms such as
+ * registers.
+ *
+ * Each type of queue also has a "status page" which may optionally be updated
+ * with cidx or pidx updates. For EQs this page consumes 1 or 2 credits at the
+ * end of the queue. For IQs it consumes 1 entry at the end of the queue.
+ *
+ * We use EQs to create Tx rings and IQs (plus FLs) to create Rx rings. We
+ * create the same number of Tx and Rx queues. So if we have 32 Tx queues, we
+ * will also have 32 Rx queues. The number of queues created is based on the
+ * port speed. The association from speed to queue count can be found in the
+ * t4_queue_counts array.
+ *
+ * Egress Queues (EQ)
+ * ------------------
+ *
+ * Egress Queues (EQ) provide communication from driver to T4. The driver writes
+ * (produces) descriptors to the queue using one or more host credits. It
+ * notifies the T4 of these new outstanding host credits by updating its pidx
+ * via a doorbell. As new outstanding credits arrive via the doorbell the T4
+ * reads (consumes) them to determine what types of descriptors have been sent
+ * along with their content. As the T4 consumes host credits it notifies the
+ * driver with a programmable combination of status page updates, CPL messages,
+ * and interrupts.
+ *
+ * All EQs use a host credit size of 8 flits (64 bytes). The driver uses these
+ * host credits to send Work Requests (WR) to the T4.
+ *
+ * A WR is variable in size and may be smaller or larger than a single host
+ * credit, but communication is always in whole units of credits. It is legal
+ * for a WR to span across the end of the queue and warp around, but the
+ * contents of the WR may dictate that the wrap-around happens only at certain
+ * offsets within the descriptor. A WR may be 16 to 512 bytes long, but must
+ * always begin at the start of a host credit, thus all WRs must start at a
+ * 64-byte aligned address.
+ *
+ * At this time the only WRs we use are FW_ETH_TX_PKT_WR and FW_ETH_TX_PKTS_WR.
+ *
+ * Ingress Queues (IQ)
+ * -------------------
+ *
+ * Ingress Queues (IQ) provide communication from T4 to driver. The T4 produces
+ * queue entries for the dirver to consume. Unlike EQs, data passed in IQs is
+ * always done as fixed-size entries. That is, each entry in the IQ takes up
+ * exactly one credit, and that credit size is determined at creation time. So
+ * in that sense you could think of a IQ entry as a descriptor. However, these
+ * entries contain different types of data of variable lengths (within in the
+ * bounds of the entry/credit size). There are four possible entry sizes, and
+ * the entry size dictates the possible messages an IQ can hold. The possibles
+ * sizes are 2 flits (16 bytes), 4 flits (32 bytes), 8 flits (64 bytes), and 16
+ * flits (128 bytes). Depending on the size, each entry may a contain Freelist
+ * buffer completion, CPL message, or a forwarded interrupt destined for another
+ * IQ. Which size to use depends on the use case of the IQ.
+ *
+ * Currently we make use of the 64-byte entry size exclusively.
+ *
+ * Freelists (FL)
+ * --------------
+ *
+ * A freelist (FL) is a type of EQ used for providing (producing) buffers for
+ * the purpose of holding received network data for an associated IQ. The driver
+ * produces pointers to DMA data buffers and the associated IQ consumes them as
+ * data is received by the device. A freelist is always associated with an IQ; a
+ * freelist is never used on its own. An IQ, however, may have no FL associated
+ * with it; such is the case for event IQs and interrupt forwarding IQs. An Rx
+ * IQ must have one or two FLs associated with it used to store the incoming
+ * packet headers and payload. The use of two FLs is for when "header splitting"
+ * is enabled: where the headers are placed in one buffer and the payload is
+ * placed in the other. Only the first 1024 IQs may have FLs associated with
+ * them.
+ *
+ * A freelist is always made up of buffer "pointers". Each buffer pointer is 1
+ * flit (8 bytes) in size and points to DMA memory used to hold packet data. The
+ * lowest four bits of the pointer are used as an index into the freelist buffer
+ * size array, allowing up to 16 different buffer sizes. This implies that each
+ * FL buffer pointer must be at least 16-byte aligned. Each pointer may use a
+ * different size. Since EQ communication must happen in units of host credits,
+ * and an EQ host credit is 8 flits, it means that the driver must always
+ * produce 8 FL buffer pointers per credit. If the driver cannot produce 8
+ * buffer pointers, the rest of the credit may be filled with zero-sized
+ * pointers ("null" or "zero" buffer) which is to say their size index points to
+ * a zero-value entry in the array.
+ *
+ * The digram below depicts how the FL buffer pointer indexes into the
+ * SGE_FL_BUFFER_SZ[N] array.
+ *
+ * +-------------------+-------------------------+
+ * | Buffer Ptr [63:4] | SGE_FL_BUFFER_SIZE[3:0] |
+ * +-------------------+-------------------------+
+ *                                  |
+ *            +---------------------+
+ *            v
+ * +--------------------+--------------------+
+ * | SGE_FL_BUFFER_SZ0  |         0          |  "zero" buffer
+ * +--------------------+--------------------+
+ * | SGE_FL_BUFFER_SZ1  |        4096        |  4K buffer
+ * +--------------------+--------------------+
+ *                      .
+ *                      .
+ *                      .
+ * +--------------------+--------------------+
+ * | SGE_FL_BUFFER_SZ15 |       16384        |  16K buffer
+ * +--------------------+--------------------+
+ *
+ * FL buffers may have "packing" enabled where a single buffer may be used for
+ * multiple packets. This requires that the driver keep track of the current
+ * offset within the current FL buffer. When a new buffer is required by the
+ * device, because the next packet will not fit in the remaining space of the
+ * current buffer, it will consume a new buffer and set a bit in the IQ
+ * completion entry to notify the driver. At this point the driver updates its
+ * cidx and restarts the offset at zero.
+ *
+ * If packing is not enabled each new packet starts at a new buffer.
+ *
+ * This driver currently sets the FL buffer size to 8192 (rx_buf_size) and
+ * enables packing.
+ *
+ * Doorbells, GTS messages, and Interrupts
+ * ---------------------------------------
+ *
+ * The driver and T4 need some way to communicate udpates to the pidx/cidx
+ * values of their queues. To achieve this goal, the driver uses a combination
+ * of doorbells, GTS messages, status pages, and interrupts.
+ *
+ * Doorbells
+ * ---------
+ *
+ * The driver informs the T4 of new EQ credits by way of a "doorbell" (DB). A
+ * doorbell is a register write directed towards a single queue. The doorbell
+ * carries a priority and an incremental update to the pidx value. There are two
+ * types of doorbells:
+ *
+ * 1. Kernel Space doorbells (KDB) which use BAR0.
+ * 2. User Space doorbells (UDB) which use BAR2.
+ *
+ * The "user space" doorbells, while useful for kernel-bypass networking, are
+ * also used for regular in-kernel networking. They divide the queue doorbell
+ * space into multiple 128 byte segments versus KDB's single address for all
+ * queues. They also provide the ability to perform Write-Combining Work
+ * Requeusts (DOORBELL_WCWR) and Write-Combining Doorbells (DOORBELL_UDBWC). The
+ * WCWR allows you to send a single credit as one write and avoid the need for
+ * the T4 to DMA the credit's contents (a WR or FL buffer pointers) from host
+ * memory. We currently make use of WCWR for the Tx datapath, but not for
+ * writing freelist descriptors.
+ *
+ * There is some more discussion of doorbells at the t4_doorbells_t definition
+ * in adapter.h.
+ *
+ * EQ Status Updates
+ * -----------------
+ *
+ * This section covers how EQ status updates work. While an FL is technically an
+ * EQ it makes no use of these mechanisms because the use of FL buffers (cidx)
+ * is tracked implicitly as CPL Rx messages arrive on the associated IQ.
+ *
+ * The driver can track the EQ cidx either by reading the EQ status page or by
+ * asking for a notification via an IQ. This is delivered by way of a
+ * CPL_SGE_EGR_UPDATE message. Furthermore, if the IQ this message is destined
+ * for has interrupts enabled, an interrupt is generated upon delivery of the
+ * message. The EQ status page update and the delivery of this message is
+ * controlled by several factors.
+ *
+ * 1. The EQ context field 'CIDXFlushThresh' (FW_EQ_ETH_CMD.cidxfthresh)
+ *    indicates how many consumed credits must be outstanding before the T4
+ *    generates a cidx update (both status page update and CPL message).
+ *
+ * 2. The EQ context field 'FCThreshOverride' (FW_EQ_ETH_CMD.cidxfthresho) tells
+ *    the T4 to generate a cidx update anytime cidx==pidx; i.e., when the T4 has
+ *    consumed all outstanding credits. This happens regardless if the cidx
+ *    flush threshold has been reached or not (thus the "override"). This is
+ *    useful for dealing with cases of intermitten transmission where the
+ *    threshold may not be reached in a timely manner.
+ *
+ * 3. The DBQ Timer (see TAF_DBQ_TIMER) provides for sending a cidx notification
+ *    anytime the EQ has sat idle (no pidx updates) for a period of time. This
+ *    is preferred to method (2) as it allows batching cidx updates while also
+ *    recycling consumed credits in a timely manner. This is available starting
+ *    with the T6 chip.
+ *
+ * 4. The FW_EQ_FLUSH_WR (its own WR on the EQ) allows the driver to request
+ *    either a status page update, EGR update, or both.
+ *
+ * 5. The FW_ETH_TX_PKT_WR and FW_ETH_TX_PKTS_WR, used to send packets, allows
+ *    the driver to request either a status page update, EGR update, or both as
+ *    part of sending the packet.
+ *
+ * This driver utilizes both the status page and CPL udpates as well as all the
+ * methods listed above to generate these updates.
+ *
+ * GTS Messages
+ * ------------
+ *
+ * The driver sends a GTS (Go To Sleep) message to the T4 to update the SGE
+ * about a specific IQ. The message conveys four pieces of information.
+ *
+ * 1. The Ingress Queue the update is for.
+ *
+ * 2. The current cidx of the driver.
+ *
+ * 3. The new timer value for pidx update scheduling (see IQ context
+ *    'Update_Scheduling' field).
+ *
+ * 4. Either a) arming the "Solicited Event" Interrupt or b) setting the new
+ *    value for the IQ context 'Update_Scheduling' field. Which one depends on
+ *    the IQ context 'GTS_Mode' value.
+ *
+ * We currently always set 'GTS_Mode=1' which indicates that the GTS 'SEIntArm'
+ * value (number 4 above) is used to dictate the new value for the
+ * 'Update_Scheduling' field.
+ *
+ * As the driver processes outstanding IQ credits it uses GTS messages to notify
+ * the driver of how many credits it has consumed and optionally re-arm the
+ * timer and packet counter notifications.
+ *
+ * The GTS messages, like the EQ Doorbells, have both kernel and user space
+ * registers. We currently only make use of the kernel space register.
+ *
+ * Ingress Queue Generation Bit
+ * ----------------------------
+ *
+ * Ingress Queues have an alternative method for pidx updates beyond the status
+ * page update or an explicit CPL message like is done for Ethernet EQs. They
+ * also provide a generation bit as part of each queue entry (credit) which can
+ * be used by the driver, after it has received an interrupt indicating new data
+ * is available, to determine which entries are newly produced by the device.
+ * This method allows you to eschew IQ status page updates altogether, and that
+ * is how we use IQs both for our firmware queue as well as our Rx data queues.
+ *
+ * Freelist Updates
+ * ----------------
+ *
+ * While an FL is technically an EQ we do not make use of explicit EQ status
+ * updates to track the FL cidx. Rather, the current FL buffer is tracked
+ * implicitly by way of the Rx IQ CPL messages generated as part of incoming
+ * traffic. As new packets come in the SGE writes the data in the current FL
+ * buffer and writes a new CPL message onto the Rx IQ. These CPL messages allow
+ * the driver to track which FL buffer is currently in use by the device and
+ * when to move onto the next FL buffer.
+ *
+ * Interrupts
+ * ----------
+ *
+ * The T4 provides interrupt capability for support of asynchrnous
+ * notifications. The primary uses of interrupts consist of the following.
+ *
+ * 1. Notification of new IQ entries (credits) available for consumption by the
+ *    driver. That is, the T4 notifies the host that of its latest IQ pidx value
+ *    indicating that there are new credits for host consumption.
+ *
+ * 2. Notification of new EQ credits available for production by the driver.
+ *    That is, the T4 notifies the host of its latest EQ cidx value indicating
+ *    that there are new credits avilable for host production.
+ *
+ * 3. Notification of firmware events (also referred to as the "firmware queue"
+ *    or "asynchronous event queue").
+ *
+ * This driver employs three different strategies for assigning interrupts
+ * depending on the type and number of interrupts available. These strategies
+ * are listed in order of preference. The solution is chosen by
+ * t4_cfg_intrs_queues() and the setup is done by t4_setup_intrs().
+ *
+ * TIP_PER_PORT
+ *
+ *     The first strategy is used when we have enough MSI/MSI-X interrupts to
+ *     dedicate one to error conditions, one for asynchronous firmware events,
+ *     and at least one for Tx/Rx events on each network port on the adapter. A
+ *     port may have more than one interrupt, in which case its Tx/Rx queue
+ *     events are distributed across those interrupts as evenly as possible. For
+ *     example, given a two-port adapter with eight interrupts, one interrupt
+ *     would be consumed for error conditions, one for firmware events, and the
+ *     remaning six would be divided as three interrupts per port. If each port
+ *     has 32 Rx queues, then two interrupts would be responsbile for 11 queues,
+ *     and the third interrupt would be responsible for 10.
+ *
+ *     The error interrupt vector points to the t4_intr_err() function. Errors
+ *     are deliverd via registers and are handled by t4_slow_intr_handler().
+ *
+ *     The asynchronous firmware event interrupt points to the t4_intr_fwq()
+ *     function and the events arrive on the firmware queue (sc->sge.fwq).
+ *
+ *     The per port interrupts point to t4_intr_port_queue() and each port's
+ *     events land on one of the per port event queues (port->intr_iqs).
+ *
+ * TIP_ERR_QUEUES
+ *
+ *     The second strategy is used when we have only two interrupts. In this
+ *     case one of the interrupts is dedicated to errors and the other one is
+ *     shared between the firmware events and the port events (Rx/Tx
+ *     notifications).
+ *
+ *     In this case the firmware and port events all land on the firmware queue
+ *     which is processed by t4_intr_fwq().
+ *
+ * TIP_SINGLE
+ *
+ *     The last strategy is for when we have a single interrupt and everything
+ *     needs to share it. In this case the interrupt lands on t4_intr_all() and
+ *     all firmware and port events go to the firmware queue.
+ *
+ * The per-port events queues (port->intr_iq) do not receive any network data
+ * themselves. Rather, they are used for two purposes:
+ *
+ * 1. To handle CPL_SGE_EGR_UPDATE messages; used to notify the driver about the
+ *    device's current cidx in a particular EQ. This is how Tx queues know when
+ *    they reclaim credits used for sending packets.
+ *
+ * 2. To handle "forwarded interrupt" notifications; used to notify the driver
+ *    that a particular receive IQ has outstanding credits to read. This is how
+ *    Rx queues know when there are new packets available to read.
+ */
+
 static void *t4_soft_state;
 
 static kmutex_t t4_adapter_list_lock;
 static list_t t4_adapter_list;
 
-struct intrs_and_queues {
-	int intr_type;		/* DDI_INTR_TYPE_* */
-	int nirq;		/* Number of vectors */
-	int intr_fwd;		/* Interrupts forwarded */
-	int ntxq10g;		/* # of NIC txq's for each 10G port */
-	int nrxq10g;		/* # of NIC rxq's for each 10G port */
-	int ntxq1g;		/* # of NIC txq's for each 1G port */
-	int nrxq1g;		/* # of NIC rxq's for each 1G port */
-};
-
-static unsigned int getpf(struct adapter *sc);
-static int prep_firmware(struct adapter *sc);
-static int upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma);
-static int partition_resources(struct adapter *sc);
-static int adap__pre_init_tweaks(struct adapter *sc);
-static int get_params__pre_init(struct adapter *sc);
-static int get_params__post_init(struct adapter *sc);
-static int set_params__post_init(struct adapter *);
-static void t4_setup_adapter_memwin(struct adapter *sc);
-static int validate_mt_off_len(struct adapter *, int, uint32_t, int,
-    uint32_t *);
+typedef enum t4_port_speed {
+	TPS_1G,
+	TPS_10G,
+	TPS_25G,
+	TPS_40G,
+	TPS_50G,
+	TPS_100G,
+	TPS_200G,
+	TPS_400G,
+} t4_port_speed_t;
+
+static uint_t t4_getpf(struct adapter *);
+static int t4_prep_firmware(struct adapter *);
+static int t4_upload_config_file(struct adapter *, uint32_t *, uint32_t *);
+static int t4_partition_resources(struct adapter *);
+static int t4_init_adap_tweaks(struct adapter *);
+static int t4_init_get_params_pre(struct adapter *);
+static int t4_init_get_params_post(struct adapter *);
+static int t4_init_set_params(struct adapter *);
+static void t4_setup_adapter_memwin(struct adapter *);
 static uint32_t t4_position_memwin(struct adapter *, int, uint32_t);
-static int init_driver_props(struct adapter *sc, struct driver_properties *p);
-static int remove_extra_props(struct adapter *sc, int n10g, int n1g);
-static int cfg_itype_and_nqueues(struct adapter *sc, int n10g, int n1g,
-    struct intrs_and_queues *iaq);
-static int add_child_node(struct adapter *sc, int idx);
-static int remove_child_node(struct adapter *sc, int idx);
-static kstat_t *setup_kstats(struct adapter *sc);
-static kstat_t *setup_wc_kstats(struct adapter *);
-static int update_wc_kstats(kstat_t *, int);
-static int t4_port_full_uninit(struct port_info *);
+static void t4_init_driver_props(struct adapter *);
+static int t4_cfg_intrs_queues(struct adapter *);
+static int t4_setup_intrs(struct adapter *);
+static int t4_add_child_node(struct adapter *, uint_t);
+static int t4_remove_child_node(struct adapter *, uint_t);
+static kstat_t *t4_setup_kstats(struct adapter *);
+static kstat_t *t4_setup_wc_kstats(struct adapter *);
+static void t4_port_full_uninit(struct port_info *);
+static t4_port_speed_t t4_port_speed(const struct port_info *);
 
 static int t4_temperature_read(void *, sensor_ioctl_scalar_t *);
 static int t4_voltage_read(void *, sensor_ioctl_scalar_t *);
+
 static const ksensor_ops_t t4_temp_ops = {
 	.kso_kind = ksensor_kind_temperature,
 	.kso_scalar = t4_temperature_read
@@ -113,7 +580,7 @@ static ddi_ufm_ops_t t4_ufm_ops = {
 	.ddi_ufm_op_getcaps = t4_ufm_getcaps
 };
 
-/* ARGSUSED */
+
 static int
 t4_devo_getinfo(dev_info_t *dip, ddi_info_cmd_t cmd, void *arg, void **rp)
 {
@@ -168,13 +635,9 @@ static int t4_devo_detach(dev_info_t *, ddi_detach_cmd_t);
 static int
 t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 {
-	struct adapter *sc = NULL;
-	struct sge *s;
-	int i, instance, rc = DDI_SUCCESS, rqidx, tqidx, q;
-	int irq = 0, nxg = 0, n1g = 0;
+	int i = 0;
+	int rc = DDI_SUCCESS;
 	char name[16];
-	struct driver_properties *prp;
-	struct intrs_and_queues iaq;
 	ddi_device_acc_attr_t da = {
 		.devacc_attr_version = DDI_DEVICE_ATTR_V0,
 		.devacc_attr_endian_flags = DDI_STRUCTURE_LE_ACC,
@@ -192,7 +655,7 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	/*
 	 * Allocate space for soft state.
 	 */
-	instance = ddi_get_instance(dip);
+	const int instance = ddi_get_instance(dip);
 	rc = ddi_soft_state_zalloc(t4_soft_state, instance);
 	if (rc != DDI_SUCCESS) {
 		cxgb_printf(dip, CE_WARN,
@@ -200,21 +663,23 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 		return (DDI_FAILURE);
 	}
 
-	sc = ddi_get_soft_state(t4_soft_state, instance);
+	struct adapter *sc = ddi_get_soft_state(t4_soft_state, instance);
 	sc->dip = dip;
 	sc->dev = makedevice(ddi_driver_major(dip), instance);
 	mutex_init(&sc->lock, NULL, MUTEX_DRIVER, NULL);
 	cv_init(&sc->cv, NULL, CV_DRIVER, NULL);
 	mutex_init(&sc->sfl_lock, NULL, MUTEX_DRIVER, NULL);
-	TAILQ_INIT(&sc->sfl);
+	list_create(&sc->sfl_list, sizeof (struct sge_fl),
+	    offsetof(struct sge_fl, sfl_node));
 	mutex_init(&sc->mbox_lock, NULL, MUTEX_DRIVER, NULL);
-	STAILQ_INIT(&sc->mbox_list);
+	list_create(&sc->mbox_list, sizeof (t4_mbox_waiter_t),
+	    offsetof(t4_mbox_waiter_t, node));
 
 	mutex_enter(&t4_adapter_list_lock);
 	list_insert_tail(&t4_adapter_list, sc);
 	mutex_exit(&t4_adapter_list_lock);
 
-	sc->pf = getpf(sc);
+	sc->pf = t4_getpf(sc);
 	if (sc->pf > 8) {
 		rc = EINVAL;
 		cxgb_printf(dip, CE_WARN,
@@ -224,8 +689,8 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	sc->mbox = sc->pf;
 
 	/* Initialize the driver properties */
-	prp = &sc->props;
-	(void) init_driver_props(sc, prp);
+	t4_init_driver_props(sc);
+	struct driver_properties *prp = &sc->props;
 
 	/*
 	 * Enable access to the PCI config space.
@@ -273,7 +738,7 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	} else {
 		if (t4_cver_ge(sc, CHELSIO_T5)) {
 			sc->doorbells |= DOORBELL_UDB;
-			if (prp->wc) {
+			if (prp->write_combine) {
 				/*
 				 * Enable write combining on BAR2.  This is the
 				 * userspace doorbell BAR and is split into 128B
@@ -312,15 +777,15 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	t4_setup_adapter_memwin(sc);
 
 	/* Prepare the firmware for operation */
-	rc = prep_firmware(sc);
+	rc = t4_prep_firmware(sc);
 	if (rc != 0)
 		goto done; /* error message displayed already */
 
-	rc = adap__pre_init_tweaks(sc);
+	rc = t4_init_adap_tweaks(sc);
 	if (rc != 0)
 		goto done;
 
-	rc = get_params__pre_init(sc);
+	rc = t4_init_get_params_pre(sc);
 	if (rc != 0)
 		goto done; /* error message displayed already */
 
@@ -336,11 +801,11 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 		}
 	}
 
-	rc = get_params__post_init(sc);
+	rc = t4_init_get_params_post(sc);
 	if (rc != 0)
 		goto done; /* error message displayed already */
 
-	rc = set_params__post_init(sc);
+	rc = t4_init_set_params(sc);
 	if (rc != 0)
 		goto done; /* error message displayed already */
 
@@ -348,7 +813,6 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	 * TODO: This is the place to call t4_set_filter_mode()
 	 */
 
-	/* tweak some settings */
 	t4_write_reg(sc, A_TP_SHIFT_CNT,
 	    V_SYNSHIFTMAX(6) |
 	    V_RXTSHIFTMAXR1(4) |
